export interface IAbstractAtom {
    source: Function | object;
    name: string | symbol;
    dependencies: IAtom[];
    dependents: IAtom[];
}
export interface IDirtyAtom<T = unknown> extends IAbstractAtom {
    isDirty: true;
    value?: T;
}
export interface ICleanAtom<T = unknown> extends IAbstractAtom {
    isDirty: false;
    value: T;
}
export declare type IAtom<T = unknown> = IDirtyAtom<T> | ICleanAtom<T>;
export declare const calculatedAtoms: IAtom[];
export declare function getAtomCreator(obj: Function | object): <V>(p: string | symbol, value?: V | undefined) => IAtom<unknown>;
//# sourceMappingURL=atoms.d.ts.map