"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.autorun = void 0;
var calculations_1 = require("./calculations");
var toRun = [];
function autorun(observableFn, _a) {
    var rerun = _a.rerun, clear = _a.clear;
    var exec = clear
        ? function () {
            clear();
            return (0, calculations_1.recalculate)(atom, observableFn);
        }
        : function () { return (0, calculations_1.recalculate)(atom, observableFn); };
    var atom = {
        dependencies: [],
        dependents: [],
        get isDirty() {
            return true;
        },
        set isDirty(val) {
            if (toRun.length === 0) {
                setTimeout(function () {
                    toRun.forEach(function (execFn) { return execFn(); });
                    toRun = [];
                });
            }
            if (val && toRun.indexOf(rerun || exec) === -1) {
                toRun.push(rerun || exec);
            }
        },
        source: observableFn,
        name: '',
    };
    return exec;
}
exports.autorun = autorun;
//# sourceMappingURL=autorun.js.map