"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.calculate = exports.recalculate = exports.linkToCalculated = exports.markAsDirty = void 0;
var atoms_1 = require("./atoms");
var Wrapper_1 = require("./Wrapper");
function markAsDirty(dependent) {
    dependent.isDirty = true;
    dependent.dependents.forEach(markAsDirty);
}
exports.markAsDirty = markAsDirty;
function unlinkDependencies(prevDependencies, atom) {
    prevDependencies
        .filter(function (dependency) { return atom.dependencies.indexOf(dependency) === -1; })
        .forEach(function (dependency) { return dependency.dependents.splice(dependency.dependents.indexOf(atom), 1); });
}
function linkToCalculated(atom) {
    if (atoms_1.calculatedAtoms.length > 0) {
        var caller = atoms_1.calculatedAtoms[atoms_1.calculatedAtoms.length - 1];
        if (caller.dependencies.indexOf(atom) === -1) {
            caller.dependencies.push(atom);
        }
        if (atom.dependents.indexOf(caller) === -1) {
            atom.dependents.push(caller);
        }
    }
}
exports.linkToCalculated = linkToCalculated;
function recalculate(atom, resultGetter, wrapper) {
    if (wrapper === void 0) { wrapper = Wrapper_1.Wrapper; }
    atoms_1.calculatedAtoms.push(atom);
    var dependencies = atom.dependencies;
    atom.dependencies = [];
    var result = resultGetter();
    // if (result !== atom.value) markAsDirty(atom);
    unlinkDependencies(dependencies, atom);
    atom.value = wrapper(result);
    atom.isDirty = false;
    atoms_1.calculatedAtoms.pop();
    return atom.value;
}
exports.recalculate = recalculate;
function calculate(atom, resultGetter, wrapper) {
    if (wrapper === void 0) { wrapper = Wrapper_1.Wrapper; }
    linkToCalculated(atom);
    if (!atom.isDirty)
        return atom.value;
    return recalculate(atom, resultGetter, wrapper);
}
exports.calculate = calculate;
//# sourceMappingURL=calculations.js.map